<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">src/components/editgrid/EditGrid.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/components/editgrid/EditGrid.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import assert from &apos;power-assert&apos;;

import Harness from &apos;../../../test/harness&apos;;
import EditGridComponent from &apos;./EditGrid&apos;;
import {
  comp1,
  comp4,
  comp3,
  comp5,
  comp6,
  comp7,
  comp8,
  comp9,
  withOpenWhenEmptyAndConditions
} from &apos;./fixtures&apos;;

import ModalEditGrid from &apos;../../../test/forms/modalEditGrid&apos;;
import Webform from &apos;../../Webform&apos;;
import { displayAsModalEditGrid } from &apos;../../../test/formtest&apos;;
import Formio from &apos;../../Formio&apos;;

describe(&apos;EditGrid Component&apos;, () =&gt; {
  it(&apos;Should set correct values in dataMap inside editGrid and allow aditing them&apos;, (done) =&gt; {
    Harness.testCreate(EditGridComponent, comp4).then((component) =&gt; {
      component.setValue([{ dataMap: { key111: &apos;111&apos; } }]);

      setTimeout(()=&gt;{
        const clickEvent = new Event(&apos;click&apos;);
        const editBtn = component.element.querySelector(&apos;.editRow&apos;);

        editBtn.dispatchEvent(clickEvent);

        setTimeout(()=&gt;{
          const keyValue = component.element.querySelectorAll(&apos;[ref=&quot;input&quot;]&apos;)[0].value;
          const valueValue = component.element.querySelectorAll(&apos;[ref=&quot;input&quot;]&apos;)[1].value;
          const saveBtnsQty = component.element.querySelectorAll(&apos;[ref=&quot;editgrid-editGrid-saveRow&quot;]&apos;).length;

          assert.equal(saveBtnsQty, 1);
          assert.equal(keyValue, &apos;key111&apos;);
          assert.equal(valueValue, &apos;111&apos;);
          done();
        }, 500);
      }, 200);
    });
  });

  it(&apos;Should set correct values after reset&apos;, (done) =&gt; {
    Harness.testCreate(EditGridComponent, comp5)
      .then((component) =&gt; {
        assert.equal(component.components.length, 0);

        component.setValue([
          { textField: &apos;textField1&apos; },
          { textField: &apos;textField2&apos; }
        ], { resetValue: true });

        setTimeout(() =&gt; {
          assert.equal(component.components.length, 2);
          done();
        }, 300);
      });
  });

  it(&apos;Should display saved values if there are more then 1 nested components&apos;, (done) =&gt; {
    Harness.testCreate(EditGridComponent, comp3).then((component) =&gt; {
      component.setValue([{ container: { number: 55555 } }, { container: { number: 666666 } }]);

      setTimeout(()=&gt;{
        const firstValue = component.element.querySelectorAll(&apos;[ref=&quot;editgrid-editGrid-row&quot;]&apos;)[0].querySelector(&apos;.col-sm-2&apos;).textContent.trim();
        const secondValue = component.element.querySelectorAll(&apos;[ref=&quot;editgrid-editGrid-row&quot;]&apos;)[1].querySelector(&apos;.col-sm-2&apos;).textContent.trim();

        assert.equal(firstValue, &apos;55555&apos;);
        assert.equal(secondValue, &apos;666666&apos;);
        done();
      }, 600);
    });
  });

  it(&apos;Should build an empty edit grid component&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(1)&apos;, &apos;Field 1&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(2)&apos;, &apos;Field 2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;0&apos;);
      Harness.testElements(component, &apos;li.list-group-header&apos;, 1);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 1);
      Harness.testElements(component, &apos;li.list-group-footer&apos;, 0);
      Harness.testElements(component, &apos;div.editRow&apos;, 0);
      Harness.testElements(component, &apos;div.removeRow&apos;, 0);
      assert.equal(component.refs[`${component.editgridKey}-addRow`].length, 1);
      assert(component.checkValidity(component.getValue()), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should build an edit grid component&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(1)&apos;, &apos;Field 1&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(2)&apos;, &apos;Field 2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;0&apos;);
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.testElements(component, &apos;li.list-group-header&apos;, 1);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testElements(component, &apos;li.list-group-footer&apos;, 0);
      Harness.testElements(component, &apos;div.editRow&apos;, 2);
      Harness.testElements(component, &apos;div.removeRow&apos;, 2);
      assert.equal(component.refs[`${component.editgridKey}-addRow`].length, 1);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(2)&apos;, &apos;foo&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(2)&apos;, &apos;bar&apos;);
      assert(component.checkValidity(component.getValue()), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should add a row when add another is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testElements(component, &apos;li.list-group-item&apos;, 1);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;0&apos;);
      Harness.clickElement(component, component.refs[`${component.editgridKey}-addRow`][0]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 2);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;0&apos;);
      Harness.clickElement(component, component.refs[`${component.editgridKey}-addRow`][0]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;0&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
    });
  });

  it(&apos;Should save a new row when save is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      component.pristine = false;
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.clickElement(component, component.refs[`${component.editgridKey}-addRow`][0]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 4);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][2][field1]&apos;, &apos;good&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][2][field2]&apos;, &apos;baz&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 4);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;3&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(4) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(4) div.row div:nth-child(2)&apos;, &apos;baz&apos;);
      assert(component.checkValidity(component.getValue()), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should cancel add a row when cancel is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.clickElement(component, component.refs[`${component.editgridKey}-addRow`][0]);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 4);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][2][field1]&apos;, &apos;good&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][2][field2]&apos;, &apos;baz&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-danger&apos;);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      assert.equal(component.editRows.length, 2);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should delete a row when delete is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;baz&apos;
        }
      ]);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;3&apos;);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.removeRow&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(2)&apos;, &apos;foo&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(2)&apos;, &apos;baz&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should edit a row when edit is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][1][field1]&apos;, &apos;good&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][1][field2]&apos;, &apos;bar&apos;);
      Harness.testElements(component, &apos;div.editgrid-actions button.btn-primary&apos;, 1);
      Harness.testElements(component, &apos;div.editgrid-actions button.btn-danger&apos;, 1);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
    });
  });

  it(&apos;Should save a row when save is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][1][field2]&apos;, &apos;baz&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(2)&apos;, &apos;baz&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should cancel edit row when cancel is clicked&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][1][field2]&apos;, &apos;baz&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-danger&apos;);
      Harness.testElements(component, &apos;li.list-group-item&apos;, 3);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(3) div.row div:nth-child(2)&apos;, &apos;bar&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should show error messages for existing data in rows&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;bad&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        },
        {
          field1: &apos;also bad&apos;,
          field2: &apos;baz&apos;
        }
      ]);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.has-error div.editgrid-row-error&apos;, &apos;Must be good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(4) div.has-error div.editgrid-row-error&apos;, &apos;Must be good&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
    });
  });

  it(&apos;Should not allow saving when errors exist&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.clickElement(component, &apos;button.btn-primary&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field1]&apos;, &apos;&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field2]&apos;, &apos;&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][0][field2]&apos;, &apos;baz&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field1]&apos;, &apos;&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field2]&apos;, &apos;baz&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][0][field1]&apos;, &apos;bad&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field1]&apos;, &apos;bad&apos;);
      Harness.getInputValue(component, &apos;data[editgrid][0][field2]&apos;, &apos;baz&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
      Harness.setInputValue(component, &apos;data[editgrid][0][field1]&apos;, &apos;good&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;1&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(1)&apos;, &apos;good&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-item:nth-child(2) div.row div:nth-child(2)&apos;, &apos;baz&apos;);
    });
  });

  it(&apos;Should not allow saving when rows are open&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-primary&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      assert(!component.checkValidity(component.getValue(), true), &apos;Item should not be valid&apos;);
      Harness.clickElement(component, &apos;div.editgrid-actions button.btn-danger&apos;);
      assert(component.checkValidity(component.getValue(), true), &apos;Item should be valid&apos;);
    });
  });

  it(&apos;Should disable components when in read only&apos;, () =&gt; {
    return Harness.testCreate(EditGridComponent, comp1, { readOnly: true }).then((component) =&gt; {
      Harness.testSetGet(component, [
        {
          field1: &apos;good&apos;,
          field2: &apos;foo&apos;
        },
        {
          field1: &apos;good&apos;,
          field2: &apos;bar&apos;
        }
      ]);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.removeRow&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
      Harness.clickElement(component, &apos;li.list-group-item:nth-child(3) div.editRow&apos;);
      Harness.testInnerHtml(component, &apos;li.list-group-header div.row div:nth-child(3)&apos;, &apos;2&apos;);
    });
  });

  describe(&apos;Display As Modal&apos;, () =&gt; {
    it(&apos;Should show add error classes to invalid components&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      form.setForm(displayAsModalEditGrid).then(() =&gt; {
        const editGrid = form.components[0];
        const clickEvent = new Event(&apos;click&apos;);
        editGrid.addRow();
        setTimeout(() =&gt; {
          const dialog = document.querySelector(&apos;[ref=&quot;dialogContents&quot;]&apos;);
          const saveButton = dialog.querySelector(&apos;.btn.btn-primary&apos;);
          saveButton.dispatchEvent(clickEvent);
          setTimeout(() =&gt; {
            assert.equal(editGrid.errors.length, 6);
            const components = Array.from(dialog.querySelectorAll(&apos;[ref=&quot;component&quot;]&apos;));
            const areRequiredComponentsHaveErrorWrapper = components.every((comp) =&gt; {
              const { className } = comp;
              return (className.includes(&apos;required&apos;) &amp;&amp; className.includes(&apos;formio-error-wrapper&apos;)) || true;
            });
            assert.equal(areRequiredComponentsHaveErrorWrapper, true);
            document.body.innerHTML = &apos;&apos;;
            done();
          }, 100);
        }, 100);
      }).catch(done);
    });

    it(&apos;Should set alert with validation errors on save and update them&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      form.setForm(ModalEditGrid).then(() =&gt; {
        const editGrid = form.components[0];

        form.checkValidity(form._data, true, form._data);
        assert.equal(form.errors.length, 1);
        editGrid.addRow();

        setTimeout(() =&gt; {
          const editRow = editGrid.editRows[0];
          const dialog = editRow.dialog;
          const saveButton = dialog.querySelector(&apos;.btn.btn-primary&apos;);
          const clickEvent = new Event(&apos;click&apos;);
          saveButton.dispatchEvent(clickEvent);

          setTimeout(() =&gt; {
            const alert = dialog.querySelector(&apos;.alert.alert-danger&apos;);
            assert.equal(form.errors.length, 3);

            const errorsLinks = alert.querySelectorAll(&apos;li&apos;);
            assert.equal(errorsLinks.length, 2);
            const textField = editRow.components[0].getComponent(&apos;textField&apos;);
            textField.setValue(&apos;new value&apos;);

            setTimeout(() =&gt; {
              const alertAfterFixingField = dialog.querySelector(&apos;.alert.alert-danger&apos;);
              assert.equal(form.errors.length, 2);

              const errorsLinksAfterFixingField = alertAfterFixingField.querySelectorAll(&apos;li&apos;);
              assert.equal(errorsLinksAfterFixingField.length, 1);

              document.body.innerHTML = &apos;&apos;;
              done();
            }, 450);
          }, 100);
        }, 100);
      }).catch(done);
    });

    it(&apos;Confirmation dialog&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      form.setForm(comp6).then(() =&gt; {
        const component = form.components[0];
        component.addRow();
        const dialog = document.querySelector(&apos;[ref=&quot;dialogContents&quot;]&apos;);
        Harness.dispatchEvent(&apos;input&apos;, dialog, &apos;[name=&quot;data[editGrid][0][textField]&quot;]&apos;, (el) =&gt; el.value = &apos;12&apos;);
        Harness.dispatchEvent(&apos;click&apos;, dialog, &apos;[ref=&quot;dialogClose&quot;]&apos;);
        const confirmationDialog = document.querySelector(&apos;[ref=&quot;confirmationDialog&quot;]&apos;);
        assert(confirmationDialog, &apos;Should open a confirmation dialog when trying to close&apos;);
        Harness.dispatchEvent(&apos;click&apos;, confirmationDialog, &apos;[ref=&quot;dialogCancelButton&quot;]&apos;);
        setTimeout(() =&gt; {
          assert.equal(component.editRows[0].data.textField, &apos;12&apos;, &apos;Data should not be cleared&apos;);

          Harness.dispatchEvent(&apos;click&apos;, dialog, &apos;[ref=&quot;dialogClose&quot;]&apos;);
          setTimeout(() =&gt; {
            const confirmationDialog2 = document.querySelector(&apos;[ref=&quot;confirmationDialog&quot;]&apos;);
            assert(confirmationDialog2, &apos;Should open again a conformation dialog&apos;);
            Harness.dispatchEvent(&apos;click&apos;, confirmationDialog2, &apos;[ref=&quot;dialogYesButton&quot;]&apos;);
            setTimeout(() =&gt; {
              assert.equal(component.editRows.length, 0, &apos;Data should be cleared&apos;);
              done();
            }, 250);
          }, 250);
        }, 250);
      }).catch(done);
    });

    it(&apos;Confirmation dialog shouldn\&apos;t occure if no values within the row are changed&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      form.setForm(comp6).then(() =&gt; {
        const component = form.components[0];
        component.setValue([
          { textField: &apos;v1&apos; }
        ]);
        setTimeout(() =&gt; {
          component.editRow(0);
          const dialog = document.querySelector(&apos;[ref=&quot;dialogContents&quot;]&apos;);
          Harness.dispatchEvent(&apos;click&apos;, dialog, &apos;[ref=&quot;dialogClose&quot;]&apos;);
          const confirmationDialog = document.querySelector(&apos;[ref=&quot;confirmationDialog&quot;]&apos;);
          assert(!confirmationDialog, &apos;Shouldn\&apos;t open a confirmation dialog when no values were changed&apos;);
          assert.equal(component.editRows[0].data.textField, &apos;v1&apos;, &apos;Data shouldn\&apos;t be changed&apos;);
          done();
        }, 150);
      }).catch(done);
    });
  });

  describe(&apos;Draft Rows&apos;, () =&gt; {
    it(&apos;Check saving rows as draft&apos;, (done) =&gt; {
      Harness.testCreate(EditGridComponent, comp5).then((component) =&gt; {
        component.addRow();
        Harness.clickElement(component, &apos;[ref=&quot;editgrid-editGrid1-saveRow&quot;]&apos;);
        assert.deepEqual(component.dataValue, [{ textField: &apos;&apos; }]);
        const isInvalid = !component.checkValidity(component.dataValue, true);
        assert(isInvalid, &apos;Item should not be valid&apos;);
        assert(component.editRows[0].state === &apos;draft&apos;, &apos;Row should be saved as draft if it has errors&apos;);
        done();
      }).catch(done);
    });

    it(&apos;Should not show row errors alerts if drafts enabled&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      ModalEditGrid.components[0].rowDrafts = true;

      form.setForm(ModalEditGrid).then(() =&gt; {
        const editGrid = form.components[0];
        editGrid.addRow();

        setTimeout(() =&gt; {
          editGrid.saveRow(0);

          setTimeout(() =&gt; {
            editGrid.editRow(0).then(() =&gt; {
              const textField = form.getComponent([&apos;editGrid&apos;, 0, &apos;form&apos;, &apos;textField&apos;]);

              textField.setValue(&apos;someValue&apos;);

              setTimeout(() =&gt; {
                Harness.dispatchEvent(&apos;click&apos;, editGrid.editRows[0].dialog, `.editgrid-row-modal-${editGrid.id} [ref=&quot;dialogClose&quot;]`);
                setTimeout(() =&gt; {
                  const dialog = editGrid.editRows[0].confirmationDialog;

                  Harness.dispatchEvent(&apos;click&apos;, dialog, &apos;[ref=&quot;dialogYesButton&quot;]&apos;);

                  setTimeout(() =&gt; {
                    editGrid.editRow(0).then(() =&gt; {
                      textField.setValue(&apos;someValue&apos;);

                      setTimeout(() =&gt; {
                        const errorAlert = editGrid.editRows[0].dialog.querySelector(`#error-list-${editGrid.id}`);
                        const hasError = textField.className.includes(&apos;has-error&apos;);

                        assert(!hasError, &apos;Should stay valid until form is submitted&apos;);
                        assert.equal(errorAlert, null, &apos;Should be valid&apos;);

                        done();
                      }, 100);
                    });
                  }, 100);
                }, 100);
              }, 100);
            });
          }, 100);
        }, 100);
      }).catch(done)
      .finally(() =&gt; {
        ModalEditGrid.components[0].rowDrafts = false;
      });
    });

    it(&apos;Should keep fields valid inside NestedForms id drafts are enabled&apos;, (done) =&gt; {
      const formElement = document.createElement(&apos;div&apos;);
      const form = new Webform(formElement);
      ModalEditGrid.components[0].rowDrafts = true;

      form.setForm(ModalEditGrid).then(() =&gt; {
        const editGrid = form.components[0];

        form.checkValidity(form._data, true, form._data);
        assert.equal(form.errors.length, 1);
        editGrid.addRow();

        setTimeout(() =&gt; {
          const editRow = editGrid.editRows[0];
          const dialog = editRow.dialog;
          const saveButton = dialog.querySelector(&apos;.btn.btn-primary&apos;);
          const clickEvent = new Event(&apos;click&apos;);
          saveButton.dispatchEvent(clickEvent);

          setTimeout(() =&gt; {
            const alert = dialog.querySelector(&apos;.alert.alert-danger&apos;);
            assert.equal(form.errors.length, 1, &apos;Should not add new errors when drafts are enabled&apos;);
            assert(!alert, &apos;Should not show an erros alert when drafts are enabled&apos;);

            const textField = editRow.components[0].getComponent(&apos;textField&apos;);
            editGrid.editRow(0);

            setTimeout(() =&gt; {
              textField.setValue(&apos;new value&apos;, { modified: true });

              setTimeout(() =&gt; {
                assert.equal(textField.dataValue, &apos;new value&apos;);
                textField.setValue(&apos;&apos;, { modified: true });

                setTimeout(() =&gt; {
                  assert.equal(textField.dataValue, &apos;&apos;);
                  assert.equal(editGrid.editRows[0].errors.length, 0, &apos;Should not add error to components inside draft row&apos;);

                  const textFieldComponent = textField.element;
                  assert(!textFieldComponent.className.includes(&apos;has-error&apos;), &apos;Should not add error class to component when drafts enabled&apos;);

                  document.innerHTML = &apos;&apos;;
                  done();
                }, 300);
              }, 300);
            }, 150);
          }, 100);
        }, 100);
      }).catch(done)
      .finally(() =&gt; {
        delete ModalEditGrid.components[0].rowDrafts;
      });
    });

    // it(&apos;&apos;, (done) =&gt; {
    //   const formElement = document.createElement(&apos;div&apos;);
    //   const form = new Webform(formElement);
    //   form.setForm(ModalEditGrid).then(() =&gt; {
    //
    //   }).catch(done);
    // });
  });

  it(&apos;Test simple conditions based on the EditGrid\&apos;s child\&apos;s value and default values when adding rows&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const form = new Webform(formElement);
    form.setForm({ display: &apos;form&apos;, components: [comp7], type: &apos;form&apos; }).then(() =&gt; {
      const component = form.getComponent([&apos;editGrid&apos;]);
      component.addRow();
      setTimeout(() =&gt; {
        Harness.getInputValue(component, &apos;data[editGrid][0][checkbox]&apos;, true, &apos;checked&apos;);
        Harness.testComponentVisibility(component, &apos;.formio-component-editGridChild&apos;, true);
        Harness.testComponentVisibility(component, &apos;.formio-component-panelChild&apos;, true);
        done();
      }, 250);
    }).catch(done);
  });

  it(&apos;Test clearOnHide inside EditGrid&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const form = new Webform(formElement);
    form.setForm({ display: &apos;form&apos;, components: [comp7], type: &apos;form&apos; }).then(() =&gt; {
      form.submission = {
        data: {
          editGrid: [
            {
              checkbox: true,
              editGridChild: &apos;Has Value&apos;,
              panelChild: &apos;Has Value Too&apos;,
            }
          ]
        }
      };
      setTimeout(() =&gt; {
        const editGrid = form.getComponent([&apos;editGrid&apos;]);
        editGrid.editRow(0).then(() =&gt; {
          Harness.dispatchEvent(&apos;click&apos;, editGrid.element, &apos;[name=&quot;data[editGrid][0][checkbox]&quot;]&apos;, el =&gt; el.checked = false);
          setTimeout(() =&gt; {
            Harness.testComponentVisibility(editGrid, &apos;.formio-component-editGridChild&apos;, false);
            Harness.testComponentVisibility(editGrid, &apos;.formio-component-panelChild&apos;, false);
            editGrid.saveRow(0, true);
            setTimeout(() =&gt; {
              assert(!form.data.editGrid[0].editGridChild, &apos;Should be cleared&apos;);
              assert(!form.data.editGrid[0].panelChild, &apos;Should be cleared&apos;);
              done();
            }, 150);
          }, 150);
        }, 150);
        });
    }).catch(done);
  });

  it(&apos;Test refreshing inside EditGrid&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const form = new Webform(formElement);
    form.setForm({ display: &apos;form&apos;, components: [comp8], type: &apos;form&apos; }).then(() =&gt; {
      const editGrid = form.getComponent([&apos;editGrid1&apos;]);
      editGrid.addRow();
      const makeSelect = form.getComponent([&apos;editGrid1&apos;, 0, &apos;make&apos;]);
      const modelSelect = form.getComponent([&apos;editGrid1&apos;, 0, &apos;model&apos;]);
      makeSelect.setValue(&apos;ford&apos;);
      setTimeout(() =&gt; {
        modelSelect.setValue(&apos;Focus&apos;);
        setTimeout(() =&gt; {
          editGrid.saveRow(0, true);
          setTimeout(() =&gt; {
            assert.equal(form.data.editGrid1[0].model, &apos;Focus&apos;, &apos;Should be saved properly&apos;);
            done();
          }, 150);
        }, 100);
      }, 150);
    }).catch(done);
  });

  it(&apos;Should display summary with values only for components that are visible at least in one row&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const form = new Webform(formElement);
    form.setForm(comp9).then(() =&gt; {
      const editGrid = form.getComponent(&apos;editGrid&apos;);

      const checkRows = (columnsNumber, rowsNumber) =&gt; {
        const rowWithColumns = editGrid.element.querySelector(&apos;.row&apos;);
        const rowsWithValues = editGrid.element.querySelectorAll(&apos;[ref=&quot;editgrid-editGrid-row&quot;]&apos;);

        assert.equal(rowWithColumns.children.length, columnsNumber, &apos;Row should contain values only for visible components&apos;);
        assert.equal(rowsWithValues.length, rowsNumber, &apos;Should have corrent number of rows&apos;);
      };

      checkRows(2, 0);
      form.setValue({
        data: {
          editGrid: [
            { textField: &apos;test1&apos;, checkbox: false },
            { textField: &apos;test2&apos;, checkbox: false },
          ],
        }
      });
      setTimeout(() =&gt; {
        checkRows(2, 2);
        form.setValue({
          data: {
            editGrid: [
              { textField: &apos;test1&apos;, checkbox: false },
              { textField: &apos;test2&apos;, checkbox: true },
            ],
          }
        });

        setTimeout(() =&gt; {
          checkRows(3, 2);
          form.setValue({
            data: {
              editGrid: [
                { textField: &apos;test1&apos;, checkbox: false },
                { textField: &apos;test2&apos;, checkbox: true, textArea: &apos;test22&apos; },
                { textField: &apos;show&apos;, checkbox: true, container: { number1: 1111 }, textArea: &apos;test3&apos; }
              ],
            }
          });

          setTimeout(() =&gt; {
            checkRows(4, 3);
            form.setValue({
              data: {
                editGrid: [
                  { textField: &apos;test1&apos;, checkbox: false },
                  { textField: &apos;test2&apos;, checkbox: false },
                  { textField: &apos;show&apos;, checkbox: false, container: { number1: 1111 } }
                ],
              }
            });

            setTimeout(() =&gt; {
              checkRows(3, 3);

              done();
            }, 300);
          }, 300);
        }, 300);
      }, 300);
    }).catch(done);
  });
});

describe(&apos;EditGrid Open when Empty&apos;, () =&gt; {
  it(&apos;Should be opened when shown conditionally&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    Formio.createForm(formElement, withOpenWhenEmptyAndConditions)
      .then((form) =&gt; {
        const radio = form.getComponent([&apos;radio&apos;]);
        radio.setValue(&apos;show&apos;);

        setTimeout(() =&gt; {
          const editGrid = form.getComponent([&apos;editGrid&apos;]);
          assert.equal(editGrid.visible, true, &apos;Should be visible&apos;);
          assert.equal(editGrid.editRows.length, 1, &apos;Should have 1 row&apos;);
          const textField = editGrid.editRows[0].components[0];
          Harness.dispatchEvent(
            &apos;input&apos;,
            textField.element,
            &apos;[name=&quot;data[editGrid][0][textField]&quot;]&apos;,
            (input) =&gt; input.value = &apos;Value&apos;
          );

          setTimeout(() =&gt; {
            const row = editGrid.editRows[0];
            console.log({ row });
            assert.equal(row.data.textField, &apos;Value&apos;, &apos;Value should be set properly&apos;);
            editGrid.saveRow(0);
            setTimeout(() =&gt; {
              assert.deepEqual(form.data.editGrid, [{ textField: &apos;Value&apos;, select1: &apos;&apos; }], &apos;Value should be saved correctly&apos;);
              radio.setValue(&apos;hide&apos;);

              setTimeout(() =&gt; {
                assert.equal(editGrid.visible, false, &apos;Should be hidden&apos;);
                radio.setValue(&apos;show&apos;);

                setTimeout(() =&gt; {
                  assert.equal(editGrid.visible, true, &apos;Should be visible&apos;);
                  assert.equal(editGrid.editRows.length, 1, &apos;Should have 1 row&apos;);
                  assert.equal(editGrid.editRows[0].state, &apos;new&apos;, &apos;Row should be a new one&apos;);
                  done();
                }, 300);
              }, 300);
            }, 350);
          }, 350);
        }, 300);
      })
      .catch(done);
  });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
